diff --git a/doc/guides/prog_guide/rte_flow.rst b/doc/guides/prog_guide/rte_flow.rst
index 0203f4f..bdb817a 100644
--- a/doc/guides/prog_guide/rte_flow.rst
+++ b/doc/guides/prog_guide/rte_flow.rst
@@ -2345,6 +2345,78 @@ Otherwise, RTE_FLOW_ERROR_TYPE_ACTION error will be returned.
    | ``mac_addr`` | MAC address   |
    +--------------+---------------+
 
+Action: ``INC_TCP_SEQ``
+^^^^^^^^^^^^^^^^^^^^^^^
+
+Increase sequence number in the outermost TCP header.
+
+It must be used with a valid RTE_FLOW_ITEM_TYPE_TCP flow pattern item.
+Otherwise, RTE_FLOW_ERROR_TYPE_ACTION error will be returned.
+
+.. _table_rte_flow_action_inc_tcp_seq:
+
+.. table:: INC_TCP_SEQ
+
+   +-----------+--------------------------------------------+
+   | Field     | Value                                      |
+   +===========+============================================+
+   | ``value`` | Value to increase TCP sequence number by   |
+   +-----------+--------------------------------------------+
+
+Action: ``DEC_TCP_SEQ``
+^^^^^^^^^^^^^^^^^^^^^^^
+
+Decrease sequence number in the outermost TCP header.
+
+It must be used with a valid RTE_FLOW_ITEM_TYPE_TCP flow pattern item.
+Otherwise, RTE_FLOW_ERROR_TYPE_ACTION error will be returned.
+
+.. _table_rte_flow_action_dec_tcp_seq:
+
+.. table:: DEC_TCP_SEQ
+
+   +-----------+--------------------------------------------+
+   | Field     | Value                                      |
+   +===========+============================================+
+   | ``value`` | Value to decrease TCP sequence number by   |
+   +-----------+--------------------------------------------+
+
+Action: ``INC_TCP_ACK``
+^^^^^^^^^^^^^^^^^^^^^^^
+
+Increase acknowledgment number in the outermost TCP header.
+
+It must be used with a valid RTE_FLOW_ITEM_TYPE_TCP flow pattern item.
+Otherwise, RTE_FLOW_ERROR_TYPE_ACTION error will be returned.
+
+.. _table_rte_flow_action_inc_tcp_ack:
+
+.. table:: INC_TCP_ACK
+
+   +-----------+--------------------------------------------------+
+   | Field     | Value                                            |
+   +===========+==================================================+
+   | ``value`` | Value to increase TCP acknowledgment number by   |
+   +-----------+--------------------------------------------------+
+
+Action: ``DEC_TCP_ACK``
+^^^^^^^^^^^^^^^^^^^^^^^
+
+Decrease acknowledgment number in the outermost TCP header.
+
+It must be used with a valid RTE_FLOW_ITEM_TYPE_TCP flow pattern item.
+Otherwise, RTE_FLOW_ERROR_TYPE_ACTION error will be returned.
+
+.. _table_rte_flow_action_dec_tcp_ack:
+
+.. table:: DEC_TCP_ACK
+
+   +-----------+--------------------------------------------------+
+   | Field     | Value                                            |
+   +===========+==================================================+
+   | ``value`` | Value to decrease TCP acknowledgment number by   |
+   +-----------+--------------------------------------------------+
+
 Negative types
 ~~~~~~~~~~~~~~
 
diff --git a/lib/librte_ethdev/rte_flow.c b/lib/librte_ethdev/rte_flow.c
index 3277be1..589d0b9 100644
--- a/lib/librte_ethdev/rte_flow.c
+++ b/lib/librte_ethdev/rte_flow.c
@@ -143,6 +143,14 @@ struct rte_flow_desc_data {
 	MK_FLOW_ACTION(SET_TTL, sizeof(struct rte_flow_action_set_ttl)),
 	MK_FLOW_ACTION(SET_MAC_SRC, sizeof(struct rte_flow_action_set_mac)),
 	MK_FLOW_ACTION(SET_MAC_DST, sizeof(struct rte_flow_action_set_mac)),
+	MK_FLOW_ACTION(INC_TCP_SEQ,
+			sizeof(struct rte_flow_action_modify_tcp_seq)),
+	MK_FLOW_ACTION(DEC_TCP_SEQ,
+			sizeof(struct rte_flow_action_modify_tcp_seq)),
+	MK_FLOW_ACTION(INC_TCP_ACK,
+			sizeof(struct rte_flow_action_modify_tcp_ack)),
+	MK_FLOW_ACTION(DEC_TCP_ACK,
+			sizeof(struct rte_flow_action_modify_tcp_ack)),
 };
 
 static int
diff --git a/lib/librte_ethdev/rte_flow.h b/lib/librte_ethdev/rte_flow.h
index c0fe879..74cd03e 100644
--- a/lib/librte_ethdev/rte_flow.h
+++ b/lib/librte_ethdev/rte_flow.h
@@ -1651,6 +1651,46 @@ enum rte_flow_action_type {
 	 * See struct rte_flow_action_set_mac.
 	 */
 	RTE_FLOW_ACTION_TYPE_SET_MAC_DST,
+
+	/**
+	 * Increase sequence number in the outermost TCP header.
+	 *
+	 * If flow pattern does not define a valid RTE_FLOW_ITEM_TYPE_TCP,
+	 * the PMD should return a RTE_FLOW_ERROR_TYPE_ACTION error.
+	 *
+	 * See struct rte_flow_action_modify_tcp_seq
+	 */
+	RTE_FLOW_ACTION_TYPE_INC_TCP_SEQ,
+
+	/**
+	 * Decrease sequence number in the outermost TCP header.
+	 *
+	 * If flow pattern does not define a valid RTE_FLOW_ITEM_TYPE_TCP,
+	 * the PMD should return a RTE_FLOW_ERROR_TYPE_ACTION error.
+	 *
+	 * See struct rte_flow_action_modify_tcp_seq
+	 */
+	RTE_FLOW_ACTION_TYPE_DEC_TCP_SEQ,
+
+	/**
+	 * Increase acknowledgment number in the outermost TCP header.
+	 *
+	 * If flow pattern does not define a valid RTE_FLOW_ITEM_TYPE_TCP,
+	 * the PMD should return a RTE_FLOW_ERROR_TYPE_ACTION error.
+	 *
+	 * See struct rte_flow_action_modify_tcp_ack
+	 */
+	RTE_FLOW_ACTION_TYPE_INC_TCP_ACK,
+
+	/**
+	 * Decrease acknowledgment number in the outermost TCP header.
+	 *
+	 * If flow pattern does not define a valid RTE_FLOW_ITEM_TYPE_TCP,
+	 * the PMD should return a RTE_FLOW_ERROR_TYPE_ACTION error.
+	 *
+	 * See struct rte_flow_action_modify_tcp_ack
+	 */
+	RTE_FLOW_ACTION_TYPE_DEC_TCP_ACK,
 };
 
 /**
@@ -2122,6 +2162,26 @@ struct rte_flow_action_set_mac {
 	uint8_t mac_addr[ETHER_ADDR_LEN];
 };
 
+/**
+ * RTE_FLOW_ACTION_TYPE_INC_TCP_SEQ
+ * RTE_FLOW_ACTION_TYPE_DEC_TCP_SEQ
+ *
+ * Increase/Decrease outermost TCP's sequence number
+ */
+struct rte_flow_action_modify_tcp_seq {
+	rte_be32_t value;
+};
+
+/**
+ * RTE_FLOW_ACTION_TYPE_INC_TCP_ACK
+ * RTE_FLOW_ACTION_TYPE_DEC_TCP_ACK
+ *
+ * Increase/Decrease TCP's acknowledgment number.
+ */
+struct rte_flow_action_modify_tcp_ack {
+	rte_be32_t value;
+};
+
 /*
  * Definition of a single action.
  *