diff --git a/doc/guides/prog_guide/rte_flow.rst b/doc/guides/prog_guide/rte_flow.rst
index a34d012..eeb9ddc 100644
--- a/doc/guides/prog_guide/rte_flow.rst
+++ b/doc/guides/prog_guide/rte_flow.rst
@@ -2345,6 +2345,74 @@ Otherwise, RTE_FLOW_ERROR_TYPE_ACTION error will be returned.
    | ``mac_addr`` | MAC address   |
    +--------------+---------------+
 
+Action: ``INC_TCP_SEQ``
+^^^^^^^^^^^^^^^^^^^^^^^
+
+Increase sequence number in the outermost TCP header.
+
+Using this action on non-matching traffic will result in undefined behavior.
+
+.. _table_rte_flow_action_inc_tcp_seq:
+
+.. table:: INC_TCP_SEQ
+
+   +----------+------------------------------------------+
+   | Field    | Value                                    |
+   +==========+==========================================+
+   | ``be32`` | Value to increase TCP sequence number by |
+   +----------+------------------------------------------+
+
+Action: ``DEC_TCP_SEQ``
+^^^^^^^^^^^^^^^^^^^^^^^
+
+Decrease sequence number in the outermost TCP header.
+
+Using this action on non-matching traffic will result in undefined behavior.
+
+.. _table_rte_flow_action_dec_tcp_seq:
+
+.. table:: DEC_TCP_SEQ
+
+   +----------+------------------------------------------+
+   | Field    | Value                                    |
+   +==========+==========================================+
+   | ``be32`` | Value to decrease TCP sequence number by |
+   +----------+------------------------------------------+
+
+Action: ``INC_TCP_ACK``
+^^^^^^^^^^^^^^^^^^^^^^^
+
+Increase acknowledgment number in the outermost TCP header.
+
+Using this action on non-matching traffic will result in undefined behavior.
+
+.. _table_rte_flow_action_inc_tcp_ack:
+
+.. table:: INC_TCP_ACK
+
+   +----------+------------------------------------------------+
+   | Field    | Value                                          |
+   +==========+================================================+
+   | ``be32`` | Value to increase TCP acknowledgment number by |
+   +----------+------------------------------------------------+
+
+Action: ``DEC_TCP_ACK``
+^^^^^^^^^^^^^^^^^^^^^^^
+
+Decrease acknowledgment number in the outermost TCP header.
+
+Using this action on non-matching traffic will result in undefined behavior.
+
+.. _table_rte_flow_action_dec_tcp_ack:
+
+.. table:: DEC_TCP_ACK
+
+   +----------+------------------------------------------------+
+   | Field    | Value                                          |
+   +==========+================================================+
+   | ``be32`` | Value to decrease TCP acknowledgment number by |
+   +----------+------------------------------------------------+
+
 Negative types
 ~~~~~~~~~~~~~~
 
diff --git a/lib/librte_ethdev/rte_flow.c b/lib/librte_ethdev/rte_flow.c
index 3277be1..d666d06 100644
--- a/lib/librte_ethdev/rte_flow.c
+++ b/lib/librte_ethdev/rte_flow.c
@@ -143,6 +143,10 @@ struct rte_flow_desc_data {
 	MK_FLOW_ACTION(SET_TTL, sizeof(struct rte_flow_action_set_ttl)),
 	MK_FLOW_ACTION(SET_MAC_SRC, sizeof(struct rte_flow_action_set_mac)),
 	MK_FLOW_ACTION(SET_MAC_DST, sizeof(struct rte_flow_action_set_mac)),
+	MK_FLOW_ACTION(INC_TCP_SEQ, sizeof(struct rte_flow_integer_action)),
+	MK_FLOW_ACTION(DEC_TCP_SEQ, sizeof(struct rte_flow_integer_action)),
+	MK_FLOW_ACTION(INC_TCP_ACK, sizeof(struct rte_flow_integer_action)),
+	MK_FLOW_ACTION(DEC_TCP_ACK, sizeof(struct rte_flow_integer_action)),
 };
 
 static int
diff --git a/lib/librte_ethdev/rte_flow.h b/lib/librte_ethdev/rte_flow.h
index f3a8fb1..5dbd6cf 100644
--- a/lib/librte_ethdev/rte_flow.h
+++ b/lib/librte_ethdev/rte_flow.h
@@ -1650,6 +1650,46 @@ enum rte_flow_action_type {
 	 * See struct rte_flow_action_set_mac.
 	 */
 	RTE_FLOW_ACTION_TYPE_SET_MAC_DST,
+
+	/**
+	 * Increase sequence number in the outermost TCP header.
+	 *
+	 * Using this action on non-matching traffic will result in
+	 * undefined behavior.
+	 *
+	 * See struct rte_flow_integer_action.
+	 */
+	RTE_FLOW_ACTION_TYPE_INC_TCP_SEQ,
+
+	/**
+	 * Decrease sequence number in the outermost TCP header.
+	 *
+	 * Using this action on non-matching traffic will result in
+	 * undefined behavior.
+	 *
+	 * See struct rte_flow_integer_action.
+	 */
+	RTE_FLOW_ACTION_TYPE_DEC_TCP_SEQ,
+
+	/**
+	 * Increase acknowledgment number in the outermost TCP header.
+	 *
+	 * Using this action on non-matching traffic will result in
+	 * undefined behavior.
+	 *
+	 * See struct rte_flow_integer_action.
+	 */
+	RTE_FLOW_ACTION_TYPE_INC_TCP_ACK,
+
+	/**
+	 * Decrease acknowledgment number in the outermost TCP header.
+	 *
+	 * Using this action on non-matching traffic will result in
+	 * undefined behavior.
+	 *
+	 * See struct rte_flow_integer_action.
+	 */
+	RTE_FLOW_ACTION_TYPE_DEC_TCP_ACK,
 };
 
 /**
@@ -2131,6 +2171,30 @@ struct rte_flow_action_set_mac {
 	uint8_t mac_addr[RTE_ETHER_ADDR_LEN];
 };
 
+/**
+ * @warning
+ * @b EXPERIMENTAL: this structure may change without prior notice
+ *
+ * General structure, containing a union of integers of all types
+ * and sizes, up to 32 bit.
+ * Intended for use by actions that require a single integer value,
+ * instead of using an action-specific structure for each of these actions.
+ */
+struct rte_flow_integer_action {
+	union rte_flow_integer {
+		rte_be32_t	be32;
+		rte_le32_t	le32;
+		uint32_t	u32;
+		int32_t		i32;
+		rte_be16_t	be16;
+		rte_le16_t	le16;
+		uint16_t	u16;
+		int16_t		i16;
+		uint8_t		u8;
+		int8_t		i8;
+	} rte_flow_int;
+};
+
 /*
  * Definition of a single action.
  *